import { StitchAppClientConfiguration } from "mongodb-stitch-core-sdk";
import NamedServiceClientFactory from "../../services/internal/NamedServiceClientFactory";
import ServiceClientFactory from "../../services/internal/ServiceClientFactory";
import StitchAuthImpl from "../auth/internal/StitchAuthImpl";
import StitchAppClient from "../StitchAppClient";
import StitchServiceClient from "../../services/StitchServiceClient";
export default class StitchAppClientImpl implements StitchAppClient {
    readonly auth: StitchAuthImpl;
    private readonly coreClient;
    private readonly info;
    private readonly routes;
    constructor(clientAppId: string, config: StitchAppClientConfiguration);
    getServiceClient<T>(factory: ServiceClientFactory<T> | NamedServiceClientFactory<T>, serviceName?: string): T;
    getGeneralServiceClient(serviceName: string): StitchServiceClient;
    callFunction(name: string, args: any[]): Promise<any>;
}
