(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var stitchPrefixKey = "__stitch.client";
    var LocalStorage = (function () {
        function LocalStorage(suiteName) {
            this.suiteName = suiteName;
        }
        LocalStorage.prototype.getKey = function (forKey) {
            return stitchPrefixKey + "." + this.suiteName + "." + forKey;
        };
        LocalStorage.prototype.get = function (key) {
            return localStorage.getItem(this.getKey(key));
        };
        LocalStorage.prototype.set = function (key, value) {
            localStorage.setItem(this.getKey(key), value);
        };
        LocalStorage.prototype.remove = function (key) {
            localStorage.removeItem(this.getKey(key));
        };
        return LocalStorage;
    }());
    exports.default = LocalStorage;
});
//# sourceMappingURL=LocalStorage.js.map